    processor 6502

    LIST OFF
    include vcs.h
    include macro.h
    include music.h
    LIST ON

;TODO: SPRITES => Add code for bummer shots
;TODO: PARTICLES => tweak shot code so that destroyed guns won't fire
;TODO: PARTICLES => Destruct bottom scenery
;TODO: PARTICLES => Add data byte (bit?) for horz direction of enemy shots
;TODO: PARTICLES => Make shots expire / fireable
;TODO: SPRITES => Add new explosion sprites
;TODO: SPRITES => Add Fighter/Scout/Advisor AI
;TODO: SPRITES => Smart Bombs
;TODO: SPRITES => Extra lives
;TODO: GAMEFRAME
;TODO: TITLESCREEN
;TODO: MUSIC / JINGLES / SFX
;TODO: PLAYTESTING
;TODO: MANUAL

; Compile switches

NTSC            = 0
PAL             = 1
COMPILE_VERSION = PAL

FAST            = 8
SLOW            = 16
SHOTFREQUENCY   = FAST

MAXOBJECTS      = 5
LINES           = 177
TOPDIFF         = 34
MIDDLEDIFF      = 18
CROSSPACE       = 121
CROSSYMIN       = 212
CROSSYMAX       = 76
CROSSXMIN       = 12
CROSSXMAX       = 147
CROSSSIZE       = 14
BOTTOMSTART     = 45
PARTICLEBASE    = 43

SPRITEMAXLEFT   = 0
SPRITEMAXRIGHT  = 141
SPRITEMAXTOP    = LINES
SPRITEMAXBOTTOM = 58
BUMMERSTOPRANGE = 25

    IF COMPILE_VERSION = PAL
BROWN       = $2A
RED         = $64
BLACK       = $00
BLUE        = $B8
WHITE       = $0F
YELLOW      = $2C
GREEN       = $5A
GREY        = $04
    ELSE
BROWN       = $FA
RED         = $44
BLACK       = $00
BLUE        = $98
WHITE       = $0F
YELLOW      = $1E
GREEN       = $CA
GREY        = $04
    ENDIF


    SEG.U vars
    ORG $80

; Both Banks:
waveCounter     ds 1                ; desired/current wave
frameCounter    ds 1                ; Incremented every frame
rnd             ds 1                ; Random #
tempVar1        ds 1
tempVar2        ds 1
tempVar3        ds 1
tempVar4        ds 1
tempPtr         ds 2

; This Bank:
xpos            ds #MAXOBJECTS      ; horizontal position of sprites
ypos            ds #MAXOBJECTS      ; vertical position of sprites
xymov           ds #MAXOBJECTS      ; horizontal motion for sprite
sprtsizetype    ds #MAXOBJECTS      ; list of sprite colors
vline           ds 1                ; current vertical line being drawn
p0count         ds 1                ; number of lines left to draw for player 0

specialon       ds 1                ; 00: ready to launch FF: already on
shipCounter     ds 1                ; Current # of ships
waveTimer       ds 1                ; indicating the length of the wave

rocketPtr1      ds 2
domePtr1        ds 2
towersPtr1      ds 2
towersPtr2      ds 2
smartiePtr1     ds 2
smartiePtr2     ds 2
smartiePtr3     ds 2
basePtr1        ds 2
cannonPtr1      ds 2
cannonPtr2      ds 2
crossMaskPtr    ds 2
crossPtr        ds 2
crossxpos       ds 1

charPtr         ds 12
SHIELDPFT       ds 6
SHIELDPFB       ds 6
bcdScore        ds 3
c7shapeptr      ds 2
c7colptr        ds 2

particlex1      ds 3
particley1      ds 3
shotstepx1      ds 1

particlex2      ds 3
particley2      ds 3
shotstepx2      ds 1
PARTICLEDATASIZE = *-particlex2

shotcounter1    ds 1
shotcounter2    ds 1
shotstepy       ds 1

    SEG     Bank0
    ORG     $F000

MainScreen
;-----------------------------------------------------------
;SPACE DISPLAY KERNEL TOP
;-----------------------------------------------------------

    STA WSYNC
    STA HMOVE
    STY VBLANK          ; End vertical blanking

    JSR DrawScore

    LDX tempVar3
    LDY sprtsizetype,X
    LDA shapeheight,Y
    STA p0count         ; Set object size
    LDA shapeptrtab,Y
    STA c7shapeptr     ; Set space object pointer
    STA c7colptr     ; Set space object pointer

    LDA xpos,X      ; A = desired X-position!
    CLC
    ADC #$08
    LDX #$01
    JSR PosElement
    STA WSYNC

    DEX
    LDA crossxpos
    JSR PosElement
    STA WSYNC

    LDA #BLUE
    STA COLUP0
    LDA #$08            ; reflect spaceships
    STA REFP1
    LDY #LINES          ; number of lines to draw on screen
    STY vline
    LDX tempVar3
    LDA (crossPtr),Y
    AND (crossMaskPtr),Y

;-----------------------------------------------------------
;SPACE DISPLAY KERNEL
;-----------------------------------------------------------

; 1. Wait for sprite to be drawn

NextWaitLine
    STA WSYNC           ; Wait for horizontal sync
    STA HMOVE
    STA GRP0
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    CPY particley1
    PHP
NextWaitLine2
    TXA
    LDX #$1F
    TXS
    TAX

    TYA
    DEY
    STY vline
    CMP ypos,X          ; Check if sprite starts now
    STA HMCLR
    BEQ DrawSprite

    STA WSYNC
    TYA
    DEY
    STY vline
    CMP ypos,X          ; Check if sprite starts now
    BEQ DrawSprite2
    LDA (crossPtr),Y
    AND (crossMaskPtr),Y
    CPY #BOTTOMSTART
    BCS NextWaitLine
    JMP BottomScape

; 2. Draw Sprite

DrawSprite
    STA WSYNC
    DEC vline
    LDY p0count
    LDA (c7shapeptr),y
    STA GRP1
    LDA (c7colptr),y
    STA COLUP1
    DEC p0count
    BMI SkipSprite

DrawSprite2
    STX tempVar2
    LDY vline
    LDA (crossPtr),Y
    AND (crossMaskPtr),Y
    STA tempVar1
    LDY p0count
    LAX (c7shapeptr),y
    LDA (c7colptr),y
    LDY vline
    CPY particley1+2

    STA WSYNC
    PHP
    STA COLUP1
    STX GRP1
    LDA tempVar1
    STA GRP0
    CPY particley1+1
    PHP
    CPY particley1
    PHP
    DEC vline
    LDX #$1F
    TXS
    LDX tempVar2

    DEC p0count
    BPL DrawSprite

; 3. Skip to next sprite

    LDA #$00
    STA WSYNC
    STA GRP1
    DEC vline

SkipSprite
    LDY vline
    LDA (crossPtr),Y
    AND (crossMaskPtr),Y
    CPY particley1+2
    STA WSYNC
    PHP
    STA GRP0
    LDA #$00
    STA GRP1
    CPY particley1+1
    PHP
    CPY particley1
    PHP

    TXA
    LDX #$1F
    TXS
    TAX

    LDY vline
    DEY
    DEY
    TYA
    SEC
    SBC #$02

    STA WSYNC
    DEX
    CMP ypos,X          ; Check if sprite starts now
    BCS Continue
    DEX
    CMP ypos,X          ; Check if sprite starts now
    BCS Continue
    DEX
    CMP ypos,X          ; Check if sprite starts now
    BCS Continue
    DEX
    CMP ypos,X          ; Check if sprite starts now
    BCS Continue
    DEX
    CMP ypos,X          ; Check if sprite starts now
    BCS Continue
    DEX
Continue
    TXA
    BPL XFine
    LDX #$00
XFine

; 4. Reposition Sprite

    LDA (crossPtr),Y
    AND (crossMaskPtr),Y
    CPY particley1+2
    STA WSYNC           ; Wait for horizontal sync
    PHP
    STA GRP0
    CPY particley1+1
    PHP
    CPY particley1
    PHP
    TXA
    LDX #$1F
    TXS
    TAX

    DEY
    DEY
    STY vline
    LDA (crossPtr),Y
    AND (crossMaskPtr),Y
    STA tempVar1

    LDY sprtsizetype,X
    LDA shapeheight,Y
    STA p0count         ; Set object size
    LDA shapeptrtab,Y
    STA c7shapeptr     ; Set space object pointer
    STA c7colptr     ; Set space object pointer

; Prepare Positioning ship
    SEC
    STA WSYNC
    LDA xpos,X      ; A = desired X-position!
.wait
    SBC #$0F        ; Battlezone calculate/wait
    BCS .wait       ; 2 in 1 magic !
    AND #$0F        ; Manuels "forget about EOR/ASL
    TAY             ; nonsense" magic :-)
    LDA hmovetab,Y  ;
    STA HMP1        ; Fine Position sprite 1
    LDY vline
    STA RESP1       ;
    LDA tempVar1
    STA WSYNC
    STA HMOVE
    STA GRP0
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    CPY particley1
    PHP
    JMP NextWaitLine2   ; Immediate WSYNC/HMOVE follows!

BottomScape
    LDA #$00
    STA CTRLPF          ; Refleceted high priority PF
    LDX #$1F
    TXS
    CPY particley1+2
    STA WSYNC
    STA.w RESP1
    PHP
    CPY particley1+1
    PHP
    CPY particley1
    PHP
    STA RESP0
    STA GRP0
    LDA #$30
    STA HMP1
    LDA #$B0
    STA HMP0
    DEY
    LDA #$80
    STA HMM0
    STA HMBL
    STA HMM1

    LDX #$FF
    TXS
    JSR Waste17

    DEY
    STA HMOVE

NextTopLine
    LDX #$1F
    TXS
    LAX (cannonPtr1),Y
    LDA CANNONCOL-TOPDIFF,Y
    CPY particley1+2
    STA WSYNC
    PHP
    CPY particley1+1
    PHP
    CPY particley1
    PHP
    STX GRP0
    STA COLUP0
    STA COLUP1
    LDA (cannonPtr2),Y
    STA GRP1
    DEY

    STA WSYNC
    LDA (cannonPtr1),Y
    STA GRP0
    LDA (cannonPtr2),Y
    STA GRP1
    DEY
    CPY #34
    BCS NextTopLine

NextShieldLine
    LDA SHIELDCOLOR-28,Y
    LDX #$1F
    TXS
    LDX SHIELDINDEX-28,Y
    STA COLUPF
    STA WSYNC
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    LDA SHIELDPFT+0,X
    STA PF0
    LDA SHIELDPFT+1,X
    STA PF1
    LDA SHIELDPFT+2,X
    STA PF2
    LDA SHIELDPFT+3,X
    STA PF0
    LDA SHIELDPFT+4,X
    STA PF1
    LDA SHIELDPFT+5,X
    STA PF2

    DEY
    LDA SHIELDCOLOR-28,Y
    STA WSYNC
    LDX SHIELDINDEX-28,Y
    STA COLUPF
    LDA SHIELDPFT+0,X
    STA PF0
    LDA SHIELDPFT+1,X
    STA PF1
    LDA SHIELDPFT+2,X
    STA PF2
    LDA SHIELDPFT+3,X
    STA PF0
    LDA SHIELDPFT+4,X
    STA PF1
    LDA SHIELDPFT+5,X
    STA PF2
    DEY
    CPY #28
    BCS NextShieldLine

    LDX #$1F
    TXS
    SLEEP 4
    LDX #BROWN
    LDA #$00
    STA PF1
    STA PF2
    LDA #$05
    STA CTRLPF          ; Refleceted high priority PF
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    STX COLUPF
    LDA #%00110000
    STA PF0
    LDA #$00
    STA GRP0
    STA GRP1
    STA RESP0
    LDA #$01
    STA HMP0
    LDA #$D0
    STA HMP1
    STA RESP1
    DEY
    LDA #%101
    STA NUSIZ1
    LDA #%110
    STA NUSIZ0
    SLEEP 13
    STA HMOVE
    LDA BOTTOMPF0,Y
    STA PF0
    LDA BOTTOMPF1,Y
    STA PF1
    LDA BOTTOMPF2,Y
    STA PF2
    DEY

NextMiddleLine
    LDX #$1F
    TXS
    LDX SMARTIECOL-MIDDLEDIFF,Y
    CPY particley1+2
    STA WSYNC
    PHP
    CPY particley1+1
    PHP
    LDA (smartiePtr1),Y
    STA GRP0
    STX COLUP0
    LDA (basePtr1),Y
    STA GRP1
    LDA (smartiePtr2),Y
    STA GRP0
    LDA BASECOL-MIDDLEDIFF,Y
    STA COLUP1
    LDA (smartiePtr3),Y
    STA GRP0
    DEY

    LDX SMARTIECOL-MIDDLEDIFF,Y
    LDA BASECOL-MIDDLEDIFF,Y
    STA COLUP1
    LDA BOTTOMPF0,Y
    STA WSYNC
    STA PF0
    LDA BOTTOMPF1,Y
    STA PF1
    LDA (smartiePtr1),Y
    STA GRP0
    STX COLUP0
    LDA BOTTOMPF2,Y
    STA PF2
    LDA (smartiePtr2),Y
    STA GRP0
    LDA (basePtr1),Y
    STA GRP1
    LDA (smartiePtr3),Y
    STA GRP0
    DEY
    CPY #19
    BCS NextMiddleLine

    STA WSYNC
    LDX #$1F
    TXS
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    LDX #$FF
    TXS
    SLEEP 11
    STA RESP1
    DEY
    JSR Waste18
    STA RESP0
    STA WSYNC
    LDA BOTTOMPF0,Y
    STA PF0
    LDA BOTTOMPF1,Y
    STA PF1
    LDA BOTTOMPF2,Y
    STA PF2
    DEY
    JSR Waste17
    JSR Waste18

NextBottomLine
    STA GRP0
    LDX #$1F
    TXS
    LDX ROCKETCOL,Y
    CPY particley1+2
    PHP
    CPY particley1+1
    PHP
    LDA (rocketPtr1),Y
    STA GRP0
    STX COLUP0
    LDA (domePtr1),Y
    STA GRP1
    LDA DOMECOL,Y
    STA COLUP1
    LDA (towersPtr1),Y
    STA GRP0
    LDA TOWERSCOL,Y
    STA COLUP0
    LDA (towersPtr2),Y
    DEY
    LDX ROCKETCOL,Y
    STA GRP0
    LDA DOMECOL,Y
    STA COLUP1
    LDA BOTTOMPF0,Y
    STA.w PF0
    LDA BOTTOMPF1,Y
    STA PF1
    LDA (rocketPtr1),Y
    STA GRP0
    STX COLUP0
    LDA (domePtr1),Y
    STA GRP1
    LDA BOTTOMPF2,Y
    STA PF2
    LDA (towersPtr1),Y
    STA GRP0
    LDA TOWERSCOL,Y
    STA COLUP0
    LDA (towersPtr2),Y
    DEY
    BPL NextBottomLine

    LDX #$FF
    TXS

    STA WSYNC
    STA WSYNC
    LDA #$00
    STA PF0
    STA PF1
    STA PF2
    STA ENABL
    STA ENAM1

    LDA #$02            ;
    STA VBLANK          ;   start vertical blanking

    IF COMPILE_VERSION = PAL
        LDA #$41            ;
    ELSE
        LDA #$23
    ENDIF

    STA TIM64T          ; 30 lines overscan

; Shield(/Surface) destruction
    LDX #$01
    JSR DestroyShield
    LDX #$00
    JSR DestroyShield

    STA CXCLR

    JSR Joy
    JMP OverscanLoop

DestroyShield
    LDA CXM1FB,X
    BPL PFNotHit
    LDY #6
    LDA particley1+1,X
    CMP #$1D
    BMI PFNotHit
    BEQ GetHorPos
    LDY #0

GetHorPos
    LDA #$20
    STA particley1+1,X  ; Relaunch Bullet (Erase later)

    LDA particlex1+1,X
    CLC
    ADC #12
    LSR
    LSR
RightHalf
    CMP #8
    BMI EORTHis
    INY
    SEC
    SBC #8
    CMP #8
    BMI UseAsIs
    INY
    SEC
    SBC #8
    CMP #8
    BMI EORTHis
    INY
    SEC
    SBC #4
    JMP RightHalf

EORTHis
    EOR #$07    ; reverse order!

UseAsIs
    TAX
    LDA disintigratetab,X
    EOR #$FF
    AND SHIELDPFT,Y
    BNE ErasePoint
    TYA
    CLC
    ADC #$06
    TAY

ErasePoint
    LDA SHIELDPFT,Y
    AND disintigratetab,X
    STA SHIELDPFT,Y

PFNotHit
    RTS

Waste18
    .byte $24   ; +3 Chews next instruction
Waste17
    NOP         ; +2
    NOP 0       ; +3
    RTS         ; JSR+RTS => +12

;-----------------------------------------------------------
; CARTRIDGE MAIN ENTRY & INIT
;-----------------------------------------------------------

Start
    CLEAN_START

    SET_POINTER rocketPtr1, ROCKET
    SET_POINTER domePtr1, DOME
    SET_POINTER towersPtr1, TOWERS
    SET_POINTER towersPtr2, TOWERS
    SET_POINTER basePtr1,    BASE-MIDDLEDIFF
    SET_POINTER cannonPtr1, CANON-TOPDIFF
    SET_POINTER cannonPtr2, CANON-TOPDIFF

    SET_POINTER crossMaskPtr, CROSSHAIR0MASK+8
    SET_POINTER crossPtr, CROSSHAIR0+9-CROSSPACE
    LDA #(CROSSXMAX-CROSSXMIN)/2+CROSSXMIN
    STA crossxpos

; Init correct GFX page
    LDX #>COLORPAGE
    STX c7colptr+1
    DEX
    STX c7shapeptr+1

; init particles
    LDA #PARTICLEBASE
    STA particley1
    STA particley2
    LDA #$09
    STA particlex1
    LDA #$9E
    STA particlex2

    LDA #40
    STA particley1+1
    LDA #60
    STA particley1+2

    LDA #30
    STA particley2+2
    LDA #70
    STA particley2+1

    LDA #30
    STA particlex1+1
    LDA #60
    STA particlex1+2

    LDA #45
    STA particlex2+2
    LDA #90
    STA particlex2+1

; Init Objects

; 1. Init Bummer shots
    LDY #$FF
    STY ypos+MAXOBJECTS-1
    LDA #VOIDBUMMERSHOTIDX
    STA sprtsizetype+MAXOBJECTS-1

; 2. Init enemies
    LDX #MAXOBJECTS-2
    LDA #VOIDSHIPIDX
InitVoids
    STA sprtsizetype,X
    STY ypos,X
    DEX
    BPL InitVoids

    LDA #$FF
    STA shotcounter1
    STA shotcounter2
    STA specialon

    LDX #11
InitShield
    STA SHIELDPFT,X
    DEX
    BPL InitShield

OverscanLoop
    LDA INTIM
    BNE OverscanLoop

;-----------------------------------------------------------
; SCREEN MAIN LOOP START WITH VSYNC
;-----------------------------------------------------------

    VERTICAL_SYNC

;-----------------------------------------------------------
; HANDLE COUNTERS/TIMERS
;-----------------------------------------------------------

    IF COMPILE_VERSION = PAL
        LDA #$4A
    ELSE
        LDA #$2C
    ENDIF

    STA TIM64T  ; set timer for next wait

; Animate Smarties
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    BCS OddFrame
    SET_POINTER smartiePtr1, SMARTIER1-MIDDLEDIFF
    SET_POINTER smartiePtr2, SMARTIER1-MIDDLEDIFF
    SET_POINTER smartiePtr3, SMARTIEL1-MIDDLEDIFF
    JMP SmartiesDone
OddFrame
    LDA #<SMARTIER2-MIDDLEDIFF
    STA smartiePtr1
    STA smartiePtr2
    LDA #<SMARTIEL2-MIDDLEDIFF
    STA smartiePtr3
SmartiesDone

    INC frameCounter
    BNE .WaveTimerOk
    INC waveTimer
.WaveTimerOk

    JSR Random
    JSR FlickerSort
    JSR particles

; Prepare Scoredisplay
    LDA #$0F
    STA COLUP0
    STA COLUP1
    LDA #%00011
    STA NUSIZ0
    STA NUSIZ1
    STA VDELP0
    STA VDELP1
    LDA #$00
    STA REFP1
    STA WSYNC
    LDX #7
.Wait
    DEX
    BNE .Wait
    STA.W RESP0
    STA RESP1
    LDA #$10
    STA HMP1
    LDX #11
NextDigit
    TXA
    LSR
    LSR
    TAY
    LDA bcdScore,Y      ; load low/high values of states
    STA tempVar1
    AND #$0F            ; select lower nibble
    TAY                 ; X-> shape of value
    LDA #>zero          ; Load pointer to desired value
    STA charPtr,X       ; Store sprite pointer
    STA charPtr-2,X       ; Store sprite pointer
    DEX
    LDA digittab,Y      ; Load pointer to desired value
    STA charPtr,X       ; Store sprite pointer
    DEX
    DEX
    LDA tempVar1         ; load low/high values of states
    LSR                 ; select higher nibble...
    LSR                 ; ...of status value (bcd!)
    LSR                 ; (numbers 0-9)
    LSR                 ;
    TAY                 ; X-> shape of value
    LDA digittab,Y      ; Load pointer to desired value
    STA charPtr,X       ; Store sprite pointer
    DEX
    BPL NextDigit
    LDA #$06
    STA tempVar2

; Prepare space display
    LDX #MAXOBJECTS-1   ; all objects
    LDA #LINES          ; number of lines to draw on screen
FindFirstSprite
    CMP ypos,X          ; Check if sprite starts now
    BCS DoThisSprite
    DEX
    BPL FindFirstSprite
    LDX #$00
DoThisSprite
    STX tempVar3

Loop2
    LDY INTIM
    BNE Loop2       ;   waste time
    JMP MainScreen

;-----------------------------------------------------------
;FLICKER SORT SUB
;-----------------------------------------------------------

FlickerSort:
    LDX #MAXOBJECTS-2
SortLoop:
    LDY sprtsizetype+1,X    ; A-> 1st sprite type and size
    LDA ypos+1,X            ; A-> 1st sprite ypos
    SEC
    SBC shapeheight,Y       ; A-> 1st sprite ypos - size
    SBC #$06                ; Fix skipping problem
    CMP ypos,X              ; 2nd Sprite drawable?
    BCS DontSwap            ; Y: All right!
SwapThis
    LDA xpos,X              ; N: Swap horizontal position
    LDY xpos+1,X
    STA xpos+1,X
    STY xpos,X
    LDA ypos,X                ; Swap vertical position
    LDY ypos+1,X
    STA ypos+1,X
    STY ypos,X
    LDA xymov,X             ; Swap horizontal movement
    LDY xymov+1,X
    STA xymov+1,X
    STY xymov,X
    LDA sprtsizetype,X             ; Swap size & type
    LDY sprtsizetype+1,X
    STA sprtsizetype+1,X
    STY sprtsizetype,X
DontSwap:
    DEX
    BPL SortLoop
AnyRTS
    RTS

;-----------------------------------------------------------
;JOYSTICK READING
;-----------------------------------------------------------

; Reading the joystick

Joy
        LDA SWCHA
        ASL
        BCS .RightDone
        LDY crossxpos
        CPY #CROSSXMAX
        BEQ .RightDone
        INC crossxpos

.RightDone
        ASL
        BCS .LeftDone
        LDY crossxpos
        CPY #CROSSXMIN
        BEQ .LeftDone
        DEC crossxpos

.LeftDone
        ASL
        BCS .DownDone
        LDY crossMaskPtr
        CPY #CROSSYMAX
        BEQ .DownDone
        INC crossPtr
        INC crossPtr
        BNE CrossShapeFine1
        INC crossPtr+1
CrossShapeFine1
        INC crossMaskPtr
        INC crossMaskPtr
        BNE .DownDone
        INC crossMaskPtr+1
.DownDone
        ASL
        BCS .UpDone
        LDY crossMaskPtr
        CPY #CROSSYMIN
        BEQ .UpDone
        DEC crossPtr
        DEC crossPtr
        LDA crossPtr
        CMP #$FE
        BNE CrossShapeFine2
        DEC crossPtr+1
CrossShapeFine2
        DEC crossMaskPtr
        DEC crossMaskPtr
        LDA crossMaskPtr
        CMP #$FE
        BNE .UpDone
        DEC crossMaskPtr+1
.UpDone

;-----------------------------------------------------------
; OWN SHOT FINALE
;-----------------------------------------------------------

    LDA shotcounter1
    BNE NoFinaleLaunch
    LDA #4
    STA shotcounter2    ; Launch
NoFinaleLaunch

    LDA shotcounter2
    BMI FinaleDone
    DEC shotcounter2
    BPL NotExpire
    LDA crossPtr
    SEC
    SBC #4*CROSSSIZE
    STA crossPtr
    BCS FinaleDone
    DEC crossPtr+1
    JMP FinaleDone

NotExpire
    LDA crossPtr
    CLC
    ADC #CROSSSIZE
    STA crossPtr
    BCC FinaleDone
    INC crossPtr+1      ; Increment Animation
FinaleDone

;-----------------------------------------------------------
;INTELLIGENT MOVE AND HANDLE ALL SPACE OBJECTS
;-----------------------------------------------------------

    LDA #$00
    STA tempVar2

    LDX #MAXOBJECTS-1
MoveNextSprite

    JSR GeneralMovement     ; General Movement

    LDA sprtsizetype,X
    CMP #VOIDBUMMERSHOTIDX
    BMI NoBummerShot
    JMP Spritedone
NoBummerShot

    CMP #VOIDSHIPIDX
    BNE NoRespawn

    LDA #$FF
    STA ypos,X          ; Keep outside visible area

    LDA tempVar2
    BMI Spritedone2
    DEC tempVar2

    LDA #3
    CMP shipCounter
    BCC Spritedone2
    JMP AddShip     ; Spawn a Ship!

NoRespawn

    LDA sprtsizetype,X
    AND #%00110000
    STA tempVar1
    LDA sprtsizetype,X
    AND #%00001111
    STA tempVar2

    CPY #$00
    BNE NoCollision

    CMP #14
    BCS NoCollision
    LDA tempVar1
    ORA #14
    STA sprtsizetype,X  ; Advance animation to explosion
    LDA #$00
    STA xymov,X         ; Clear movement
    BEQ Spritedone

NoCollision

    LDA tempVar1
    CMP #BUMMERIDX ; Are we a Bummer?
    BNE NoBummer
    LDA tempVar2
    CMP #14
    BCS NoSpecialX  ; busy with exploding
    LDA xymov,X
    AND #%00000001
    TAY
    LDA xpos,X
    CMP BUMMERSTOP,Y
    BNE NoSpecialX
ExpireMe
    LDA tempVar1           ; Zoom out
    ORA #9
    STA sprtsizetype,X
Spritedone2
    JMP Spritedone

NoBummer
    CMP #FIGHTERIDX ; Are we a Fighter?
    BEQ NoSpecialX
    LDA frameCounter
    BNE NoSpecialX
    LDA waveTimer
    AND #$03
    BNE NoSpecialX
    LDA tempVar2
    CMP #9
    BCC ExpireMe

NoSpecialX
    LDY tempVar2
    LDA #7
    CPY #14
    BCC FastAnim
    LDA #$1F
FastAnim
    AND frameCounter
    BNE Spritedone

    INY
    CPY #14
    BEQ DoRemove
    CPY #16
    BNE NoRemove

DoRemove
    LDA tempVar1
    BEQ NoSpecialRemove
    DEC specialon

NoSpecialRemove
    DEC shipCounter
    LDA #$FF
    STA ypos,X
    LDA #VOIDSHIPIDX
    STA sprtsizetype,X
    BNE Spritedone

NoRemove
    CPY #$09
    BNE AnimFine
    LDY #$05
AnimFine
    TYA
    AND #%00001111
    ORA tempVar1
    STA sprtsizetype,X

Spritedone
    DEX
    BMI Handlerdone
    JMP MoveNextSprite
Handlerdone
    RTS


;-----------------------------------------------------------
;ADD NEW SHIP
;-----------------------------------------------------------

AddShip
    LDA #$00
    BIT specialon
    BPL NoSpecial
    STA specialon
    JSR Random
    AND #%00110000
    BNE NoSpecial        ; NOT! :-)
    DEC specialon
NoSpecial
    STA sprtsizetype,X

    CMP #BUMMERIDX ; Are we a Bummer?
    BNE OtherShip

    LDA #SPRITEMAXTOP
    STA ypos,X
    LDA rnd
    AND #%00000001
    TAY
    LDA BUMMERSTART,Y
    STA xpos,X
    LDA BUMMERDIR,Y
    STA xymov,x
    BNE AddDone

OtherShip
    JSR Random
    AND #%01111111
    ADC #6
    STA xpos,X
    AND #$07
    TAY
    LDA DIRTAB,Y
    STA xymov,x

    JSR Random
    AND #%00111111
    ADC #100
    STA ypos,X

AddDone
    INC shipCounter
    JMP Spritedone

;-----------------------------------------------------------
;ADD NEW SHOT
;-----------------------------------------------------------

;AddShot
;    LDY #MAXOBJECTS/2   ; Only check half the objects...
;
;.SearchAttacker
;    LDA sprtsizetype,Y
;    CMP #$28
;    BMI .CheckNext
;    AND #$07
;    STA tempVar3
;    LDA xpos,Y
;    BMI .CheckNext
;    LDA ypos,Y
;    CMP #$3F
;    BCS .CheckNext
;    SBC tempVar3
;    LDA #$10
;;    STA ypos,X
;    LDA xpos,Y
;    STA xpos,X
;    LDA #%10000110
;    STA zmov,X
;    LDA #$00
;    STA xymov,X
;    LDA tempVar3
;    LSR
;    ORA #$10            ; Shotsize depends on enemy size!
;    STA sprtsizetype,X
;    LDA #$08            ; Shot sound
;    STA AUDC1
;
;    LDA waveCounter     ; Tie Advance behaviour!
;    AND #%00000010
;    BEQ SpriteMoveOk
;    LDA rnd
;    AND #$0F
;    STA xymov,Y
;    AND #%00001010
;    BNE SpriteMoveOk
;    LDA xymov,Y
;    ORA #%00001010
;    STA xymov,Y
;
;SpriteMoveOk
;    LDA shotcounter1init
;    STA shotCounter
;;    JMP Spritedone
;
;.CheckNext
;    DEY
;    BPL .SearchAttacker
;;    JMP Spritedone

;-----------------------------------------------------------
;ITERATE A RANDOM VALUE
;-----------------------------------------------------------

Random
    LDA rnd
    BNE .skipInit
    LDA #$FF
.skipInit:
    ASL
    ASL
    ASL
    EOR rnd
    ASL
    ROL rnd
    RTS

;-----------------------------------------------------------
;HANDLE GENERAL XY MOVEMENT
;-----------------------------------------------------------

GeneralMovement
    LDA frameCounter
    LSR
    BCC .UpDoneX

    LDA xymov,X
    LSR
    BCC .RightDoneX
    INC xpos,X
    LDY xpos,X
    CPY #SPRITEMAXRIGHT
    BNE .RightDoneX
ReverseHorz
    LDA xymov,X
    EOR #%00000011
    STA xymov,X
    JMP .UpDoneX

.RightDoneX
    LSR
    BCC .LeftDoneX
    DEC xpos,X

    LDY xpos,X
    CPY #SPRITEMAXLEFT
    BEQ ReverseHorz

.LeftDoneX
    LSR
    BCC .DownDoneX
    DEC ypos,X

    LDY ypos,X
    CPY #SPRITEMAXBOTTOM
    BNE .DownDoneX
ReverseVert
    LDA xymov,X
    EOR #%00001100
    STA xymov,X
    JMP .UpDoneX


.DownDoneX
    LSR
    BCC .UpDoneX
    INC ypos,X

    LDY ypos,X
    CPY #SPRITEMAXTOP
    BEQ ReverseVert

.UpDoneX

;-----------------------------------------------------------
;COLLISION DETECTION
;-----------------------------------------------------------

    LDY sprtsizetype,X
    LDA #8
    ADC shapeheight,Y
    STA tempVar1
    LDA crossxpos
    SBC #3
    SBC xpos,X
    BMI .NoHit
    SBC #11
    BPL .NoHit
    LDA crossMaskPtr
    SEC
    SBC #CROSSYMAX+4
    EOR #$FF
    CLC
    ADC #45
    ADC tempVar1
    SBC ypos,X
    BMI .NoHit
    SBC tempVar1
    BPL .NoHit
    LDA shotcounter2
    CMP #2              ; Shot expired this or next frame?
    BCS .NoHit
    LDY #$00
    RTS

.NoHit
    LDY #$FF
    RTS

particles
    LDX #PARTICLEDATASIZE-1
FlickerParticles
    LDA particlex1,X
    LDY particlex2,X
    STA particlex2,X
    STY particlex1,X
    DEX
    BPL FlickerParticles

    LDA shotcounter1
    BPL MoveShot
    LDY INPT4
    BMI DontMoveShot

; Determine horizontal stepwidth
    LDA crossxpos
    CLC
    ADC #$04
    STA tempVar1

    LDX #0
    JSR GetHorzStepWidth
    LDX #particlex2-particlex1
    LDA tempVar1
    JSR GetHorzStepWidth

; Determine vertical stepwidth
    LDA crossMaskPtr
    SEC
    SBC #CROSSYMAX+4
    EOR #$FF
    CLC
    ADC #$01

    IF SHOTFREQUENCY = FAST
        LSR
        LSR
    ELSE
        LSR
        LSR
        LSR
    ENDIF

    BNE StepFine2
    LDA #$01
StepFine2
    STA shotstepy

; Start timer
    LDA #SHOTFREQUENCY-2
    STA shotcounter1
    BNE DontMoveShot

MoveShot
    DEC shotcounter1
    BMI ExpireShot

    LDA particley1
    CLC
    ADC shotstepy
    ORA #%00000001
    TAX

    LDA particlex1
    CLC
    ADC shotstepx1
    BNE SetShotPosition

ExpireShot
    LDX #PARTICLEBASE
    LDA #$9E
    STA particlex2
    STX particley2
    LDA #$09

SetShotPosition
    STA particlex1
    STX particley1

DontMoveShot
    LDX #$02
    LDA particlex1
    JMP EdgeFine

NextParticle
    LDA particley1-2,X
    BEQ NoVisibleParticle
    DEC particlex1-2,X
    DEC particley1-2,X
    DEC particley1-2,X
    BNE NoVisibleParticle
    LDA #LINES
    STA particley1-2,X

NoVisibleParticle
    LDA particlex1-2,X
    CMP #$06
    BNE EdgeFine
    LDA #$A0
    STA particlex1-2,X
EdgeFine
    JSR PosElement
    INX
    CPX #$05
    BNE NextParticle

    STA WSYNC
    STA HMOVE
    STA WSYNC
    STA HMCLR
ParticlesDone
    RTS

GetHorzStepWidth
    LDY particlex1,X
    CPY #$09
    BNE OtherSubtraction
    SEC
    SBC particlex1,X
    JMP SubtractionDone

OtherSubtraction
    LDA particlex1,X
    SEC
    SBC tempVar1

SubtractionDone
    IF SHOTFREQUENCY = FAST
        LSR
        LSR
    ELSE
        LSR
        LSR
        LSR
    ENDIF
    BNE StepFine
    LDA #$01
StepFine
    CPY #$09
    BEQ NotNeg
    EOR #%11111111
    CLC
    ADC #$01
NotNeg
    STA shotstepx1,X
    RTS

    ORG $FA00
CROSSHAIR0
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00000000
    .byte %00000000
    .byte %11000110
    .byte %11000110
    .byte %00000000
    .byte %00000000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000

CROSSHAIR1
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00000000
    .byte %00000000
    .byte %11010110
    .byte %11010110
    .byte %00000000
    .byte %00000000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000


CROSSHAIR2
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %11111110
    .byte %11111110
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000

CROSSHAIR3
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00111000
    .byte %00111000
    .byte %11111110
    .byte %11111110
    .byte %00111000
    .byte %00111000
    .byte %00010000
    .byte %00010000
    .byte %00010000
    .byte %00010000

CROSSHAIR4
    .byte %00010000
    .byte %00010000
    .byte %00111000
    .byte %00111000
    .byte %01111100
    .byte %01111100
    .byte %11111110
    .byte %11111110
    .byte %01111100
    .byte %01111100
    .byte %00111000
    .byte %00111000
    .byte %00010000
    .byte %00010000

PosElement
        SEC
        STA WSYNC                ;
.waitzone
        SBC #$0F                 ;
        BCS .waitzone            ; RESP loop
        EOR #$07                 ;
        ASL                      ;
        ASL                      ;
        ASL                      ;
        ASL                      ;
        STA HMP0,X
        STA RESP0,X
        RTS                      ; done, that's all!

DrawScore
; slightly modified 48 pixel version:
loop2
        LDY tempVar2           ;+3  63  189
        SLEEP 4
        LDA     (charPtr),y     ;+5  68  204
        STA     WSYNC           ;go
        STA.w   GRP0            ;+3  71  213      D1     --      --     --
        LDA     (charPtr+$2),y  ;+5   5   15
        STA     GRP1            ;+3   8   24      D1     D1      D2     --
        LDA     (charPtr+$4),y  ;+5  13   39
        STA     GRP0            ;+3  16   48      D3     D1      D2     D2
        LDA     (charPtr+$6),y  ;+5  21   63
        STA     tempVar1         ;+3  24   72
        LAX     (charPtr+$8),y  ;+5  29   87
        LDA     (charPtr+$A),y  ;+5  36  108
        LDY     tempVar1         ;+3  41  123              !
        STY     GRP1            ;+3  44  132      D3     D3      D4     D2!
        STX     GRP0            ;+3  47  141      D5     D3!     D4     D4
        STA     GRP1            ;+3  50  150      D5     D5      D6     D4!
        STA     GRP0            ;+3  53  159      D4*    D5!     D6     D6
        DEC     tempVar2           ;+5  58  174                             !
        BPL     loop2           ;+2  60  180
        LDY #0
        STY GRP0
        STY GRP1
        STY GRP0
        STY NUSIZ0
        STY NUSIZ1
        STY VDELP0
        STY VDELP1
        RTS                      ; done, that's all!

    ORG $FB00

ROCKETCOL
                                .byte   BLACK
                                .byte   RED
                                .byte   RED
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   WHITE
                                .byte   WHITE
                                .byte   WHITE
                                .byte   WHITE
                                .byte   WHITE
                                .byte   WHITE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE

TOWERSCOL
                                .byte   BLACK
                                .byte   GREY
                                .byte   GREY
                                .byte   BLUE
                                .byte   BLUE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   BLUE
                                .byte   BLUE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   WHITE

shapeheight
    .byte $02,$02,$03,$03,$03
    .byte $03,$03,$03,$03
    .byte $03,$03,$03,$02,$02
    .byte $03, $03

    .byte $03,$03,$03,$04,$04
    .byte $05,$05,$05,$05
    .byte $04,$04,$03,$03,$03
    .byte $05, $05

    .byte $06,$06,$06,$06,$06
    .byte $06,$06,$06,$06
    .byte $06,$06,$06,$06,$06
    .byte $06, $06

    .byte $03,$03,$04,$05,$06
    .byte $07,$07,$07,$07
    .byte $06,$05,$04,$03,$03
    .byte $07, $07

    .byte $00

    .byte $00

    .byte $02,$02,$02,$02

shapeptrtab
FIGHTERIDX = *-shapeptrtab
    .byte <FIGHTERZ0,<FIGHTERZ1,<FIGHTERZ2,<FIGHTERZ3,<FIGHTERZ4
    .byte <FIGHTER0,<FIGHTER1,<FIGHTER2,<FIGHTER3
    .byte <FIGHTERZ4,<FIGHTERZ3,<FIGHTERZ2,<FIGHTERZ1,<FIGHTERZ0
    .byte <FIGHTEREXP1,<FIGHTEREXP2

ADVISORIDX = *-shapeptrtab
    .byte <ADVISOR0,<ADVISOR1,<ADVISOR2,<ADVISOR3,<ADVISOR4
    .byte <ADVISOR5,<ADVISOR5,<ADVISOR5,<ADVISOR5
    .byte <ADVISOR4,<ADVISOR3,<ADVISOR2,<ADVISOR1,<ADVISOR0
    .byte <ADVISOREXP1,<ADVISOREXP2

BUMMERIDX = *-shapeptrtab
    .byte <BUMMERZ0,<BUMMERZ1,<BUMMERZ2,<BUMMERZ3,<BUMMERZ4
    .byte <BUMMER0,<BUMMER1,<BUMMER2,<BUMMER3
    .byte <BUMMERZ4,<BUMMERZ3,<BUMMERZ2,<BUMMERZ1,<BUMMERZ0
    .byte <BUMMEREXP1,<BUMMEREXP2

SCOUTIDX = *-shapeptrtab
    .byte <SCOUTZ0,<SCOUTZ1,<SCOUTZ2,<SCOUTZ3,<SCOUTZ4
    .byte <SCOUT0,<SCOUT1,<SCOUT2,<SCOUT3
    .byte <SCOUTZ4,<SCOUTZ3,<SCOUTZ2,<SCOUTZ1,<SCOUTZ0
    .byte <SCOUTEXP1,<SCOUTEXP2

VOIDSHIPIDX = *-shapeptrtab
    .byte <VOIDSHIP

VOIDBUMMERSHOTIDX = *-shapeptrtab
    .byte <VOIDBUMMERSHOT

BUMMERSHOTIDX = *-shapeptrtab
    .byte <BUMMERSHOT1,<BUMMERSHOT2,<BUMMERSHOT3,<BUMMERSHOT4

zero
    .byte %00111100
    .byte %01000010
    .byte %01000010
    .byte %01000010
    .byte %01000010
    .byte %01000010
    .byte %00111100

one
    .byte %00001000
    .byte %00001000
    .byte %00001000
    .byte %00001000
    .byte %00001000
    .byte %00011000
    .byte %00001000

two
    .byte %01111110
    .byte %01000000
    .byte %00100000
    .byte %00011100
    .byte %00000010
    .byte %01000010
    .byte %00111100

three
    .byte %00111100
    .byte %01000010
    .byte %00000010
    .byte %00111100
    .byte %00000010
    .byte %01000010
    .byte %00111100

four
    .byte %00000100
    .byte %00000100
    .byte %01111110
    .byte %00100100
    .byte %00010100
    .byte %00001100
    .byte %00000100

five
    .byte %00111100
    .byte %01000010
    .byte %00000010
    .byte %01111100
    .byte %01000000
    .byte %01000000
    .byte %01111100

six
    .byte %00111100
    .byte %01000010
    .byte %01000010
    .byte %01111100
    .byte %01000000
    .byte %01000010
    .byte %00111100

seven
    .byte %01000000
    .byte %00100000
    .byte %00010000
    .byte %00001000
    .byte %00000100
    .byte %00000010
    .byte %01111110

eight
    .byte %00111100
    .byte %01000010
    .byte %01000010
    .byte %00111100
    .byte %01000010
    .byte %01000010
    .byte %00111100

nine
    .byte %00111100
    .byte %01000010
    .byte %00000010
    .byte %00111110
    .byte %01000010
    .byte %01000010
    .byte %00111100

BUMMERSTART
    .byte SPRITEMAXRIGHT, SPRITEMAXLEFT

BUMMERSTOP
    .byte SPRITEMAXLEFT+BUMMERSTOPRANGE,SPRITEMAXRIGHT-BUMMERSTOPRANGE

BUMMERDIR
    .byte %00000010, %00000001

    ORG $FC00
CROSSHAIR0MASK
    ds CROSSPACE, 0
    ds 14, $FF
    ds CROSSPACE, 0

; Page with Space objects
    ORG $FD00

VOIDBUMMERSHOT
VOIDSHOT
VOIDSHIP
ADVISOR0
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
ADVISOR1
                                .byte   %00010000
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
ADVISOR2
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00000000
ADVISOR3
                                .byte   %00111000
                                .byte   %00010000
                                .byte   %00111000
                                .byte   %00000000
                                .byte   %00000000
ADVISOR4
                                .byte   %00111000
                                .byte   %00010000
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %00000000
ADVISOR5
                                .byte   %00111100
                                .byte   %00011000
                                .byte   %01111110
                                .byte   %00111100
                                .byte   %00111100
                                .byte   %00011000
BUMMERZ0
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
BUMMERZ1
                                .byte   %00111000
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
BUMMERZ2
                                .byte   %00101000
                                .byte   %00111000
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
BUMMERZ3
                                .byte   %01101100
                                .byte   %00101000
                                .byte   %00111000
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
BUMMERZ4
                                .byte   %11101110
                                .byte   %01000100
                                .byte   %01111100
                                .byte   %01000100
                                .byte   %00111000
                                .byte   %00000000
                                .byte   %00000000
BUMMER0
                                .byte   %11101110
                                .byte   %01000100
                                .byte   %01010100
                                .byte   %01111100
                                .byte   %01000100
                                .byte   %00111000
                                .byte   %00010000
BUMMER1
                                .byte   %11101110
                                .byte   %01000100
                                .byte   %01010100
                                .byte   %01111100
                                .byte   %01000100
                                .byte   %00111000
                                .byte   %00010000
BUMMER2
                                .byte   %11101110
                                .byte   %01000100
                                .byte   %01010100
                                .byte   %01111100
                                .byte   %01000100
                                .byte   %00111000
                                .byte   %00010000
BUMMER3
                                .byte   %11101110
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %01111100
                                .byte   %01000100
                                .byte   %00111000
                                .byte   %00000000
FIGHTERZ0
                                .byte   %00010000
                                .byte   %00000000
                                .byte   %00000000
FIGHTERZ1
                                .byte   %00010000
                                .byte   %00010000
                                .byte   %00000000
FIGHTERZ2
                                .byte   %00010000
                                .byte   %00101000
                                .byte   %00010000
                                .byte   %00000000
FIGHTERZ3
                                .byte   %00011000
                                .byte   %00100100
                                .byte   %00011000
                                .byte   %00000000
FIGHTERZ4
                                .byte   %00011000
                                .byte   %00100100
                                .byte   %00100100
                                .byte   %00011000
FIGHTER0
                                .byte   %00111000
                                .byte   %01100100
                                .byte   %01100100
                                .byte   %00111000
FIGHTER1
                                .byte   %00111000
                                .byte   %01010100
                                .byte   %01010100
                                .byte   %00111000
FIGHTER2
                                .byte   %00111000
                                .byte   %01001100
                                .byte   %01001100
                                .byte   %00111000
FIGHTER3
                                .byte   %00111000
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %00111000
SCOUTZ0
                                .byte   %01000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
SCOUTZ1
                                .byte   %01100000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
SCOUTZ2
                                .byte   %01110000
                                .byte   %01010000
                                .byte   %01010000
                                .byte   %00000000
                                .byte   %00000000
SCOUTZ3
                                .byte   %00100000
                                .byte   %01110000
                                .byte   %01010000
                                .byte   %01010000
                                .byte   %11011000
                                .byte   %00000000
SCOUTZ4
                                .byte   %00110000
                                .byte   %01111000
                                .byte   %01111000
                                .byte   %01001000
                                .byte   %01001000
                                .byte   %01001000
                                .byte   %11011100
SCOUT0
                                .byte   %00101000
                                .byte   %01111100
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %01010100
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %11100110
SCOUT1
                                .byte   %00110000
                                .byte   %01111100
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %01010100
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %11001110
SCOUT2
                                .byte   %00010000
                                .byte   %01111100
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %01010100
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %11101100
SCOUT3
                                .byte   %00011000
                                .byte   %01111100
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %01010100
                                .byte   %01000100
                                .byte   %01000100
                                .byte   %01101110
BUMMERSHOT1
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00011000
BUMMERSHOT2
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00011000
BUMMERSHOT3
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00011000
BUMMERSHOT4
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00011000
ADVISOREXP1
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00111100
                                .byte   %00000000
                                .byte   %00011000
ADVISOREXP2
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00011000

BUMMEREXP1
                                .byte   %11101110
                                .byte   %00000000
                                .byte   %01010100
                                .byte   %00000000
                                .byte   %01000100
                                .byte   %00000000
                                .byte   %00010000
BUMMEREXP2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %01010100
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00010000

FIGHTEREXP1
                                .byte   %00111000
                                .byte   %00000000
                                .byte   %01000100
                                .byte   %00000000
FIGHTEREXP2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %01000100
                                .byte   %00000000

SCOUTEXP1
                                .byte   %00000000
                                .byte   %01111100
                                .byte   %00000000
                                .byte   %00111000
                                .byte   %00000000
                                .byte   %01000100
                                .byte   %00000000
                                .byte   %11100110
SCOUTEXP2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00111000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100110

; Page with Space object colors
    ORG $FE00
COLORPAGE
ADVISORCOLOR0
                                .byte   WHITE
                                .byte   $00
                                .byte   $00
                                .byte   $00
ADVISORCOLOR1
                                .byte   WHITE
                                .byte   WHITE
                                .byte   $00
                                .byte   $00
ADVISORCOLOR2
                                .byte   WHITE
                                .byte   WHITE
                                .byte   $00
                                .byte   $00
ADVISORCOLOR3
                                .byte   WHITE
                                .byte   GREEN
                                .byte   WHITE
                                .byte   $00
                                .byte   $00
ADVISORCOLOR4
                                .byte   WHITE
                                .byte   GREEN
                                .byte   WHITE
                                .byte   GREEN
                                .byte   $00
ADVISORCOLOR5
                                .byte   WHITE
                                .byte   GREEN
                                .byte   WHITE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   YELLOW
BUMMERZCOLOR0
                                .byte   GREY
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
BUMMERZCOLOR1
                                .byte   GREY
                                .byte   GREY
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
BUMMERZCOLOR2
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   $00
                                .byte   $00
                                .byte   $00
                                .byte   $00
BUMMERZCOLOR3
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   $00
                                .byte   $00
                                .byte   $00
BUMMERZCOLOR4
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   $00
                                .byte   $00
BUMMERCOLOR0
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREEN
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   GREEN
BUMMERCOLOR1
                                .byte   BLUE
                                .byte   GREY
                                .byte   YELLOW
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   YELLOW
BUMMERCOLOR2
                                .byte   BLUE
                                .byte   GREY
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   BLUE
BUMMERCOLOR3
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   $00
FIGHTERZCOLOR0
                                .byte   RED
                                .byte   $00
                                .byte   $00
FIGHTERZCOLOR1
                                .byte   RED
                                .byte   YELLOW
                                .byte   $00
FIGHTERZCOLOR2
                                .byte   RED
                                .byte   BLUE
                                .byte   RED
                                .byte   $00
FIGHTERZCOLOR3
                                .byte   RED
                                .byte   GREEN
                                .byte   RED
                                .byte   $00
FIGHTERZCOLOR4
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
FIGHTERCOLOR0
                                .byte   RED
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   RED
FIGHTERCOLOR1
                                .byte   RED
                                .byte   BLUE
                                .byte   BLUE
                                .byte   RED
FIGHTERCOLOR2
                                .byte   RED
                                .byte   GREEN
                                .byte   GREEN
                                .byte   RED
FIGHTERCOLOR3
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
SCOUTZCOLOR0
                                .byte   YELLOW
                                .byte   $00
                                .byte   $00
                                .byte   $00
SCOUTZCOLOR1
                                .byte   YELLOW
                                .byte   BLUE
                                .byte   $00
                                .byte   $00
SCOUTZCOLOR2
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
                                .byte   $00
                                .byte   $00
SCOUTZCOLOR3
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
                                .byte   $00
SCOUTZCOLOR4
                                .byte   BLUE
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
SCOUTCOLOR0
                                .byte   YELLOW
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
SCOUTCOLOR1
                                .byte   BLUE
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
SCOUTCOLOR2
                                .byte   YELLOW
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
SCOUTCOLOR3
                                .byte   GREEN
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE

BUMMERSHOTCOLOR1
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
BUMMERSHOTCOLOR2
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
BUMMERSHOTCOLOR3
                                .byte   GREEN
                                .byte   GREEN
                                .byte   GREEN
BUMMERSHOTCOLOR4
                                .byte   RED
                                .byte   RED
                                .byte   RED
ADVISOREXPCOLOR1
                                .byte   WHITE
                                .byte   GREEN
                                .byte   WHITE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   YELLOW
ADVISOREXPCOLOR2
                                .byte   WHITE
                                .byte   GREEN
                                .byte   WHITE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   YELLOW

BUMMEREXPCOLOR1
                                .byte   BLUE
                                .byte   GREY
                                .byte   YELLOW
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   YELLOW
BUMMEREXPCOLOR2
                                .byte   BLUE
                                .byte   GREY
                                .byte   YELLOW
                                .byte   GREY
                                .byte   GREY
                                .byte   GREY
                                .byte   YELLOW
FIGHTEREXPCOLOR1
                                .byte   RED
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   RED
FIGHTEREXPCOLOR2
                                .byte   RED
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   RED
SCOUTEXPCOLOR1
                                .byte   YELLOW
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE
SCOUTEXPCOLOR2
                                .byte   YELLOW
                                .byte   GREEN
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   YELLOW
                                .byte   BLUE

    ORG $FF00

BOTTOMPF0
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %01110000
                                .byte   %00110000
                                .byte   %00110000
                                .byte   %00110000

BOTTOMPF1
                                .byte   %11111111
BOTTOMPF2
                                .byte   %11111111

                                .byte   %00111111
                                .byte   %11111111

                                .byte   %00111100
                                .byte   %11111100
                                .byte   %00011000
                                .byte   %11111100
                                .byte   %00011000
                                .byte   %11111100

                                .byte   %00011000
                                .byte   %11111000
                                .byte   %00001000
                                .byte   %11111000
                                .byte   %00001000
                                .byte   %11111000

                                .byte   %00001000
                                .byte   %11110000
                                .byte   %00001000
                                .byte   %11110000

                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

ROCKET
                                .byte   %00000000
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %00111110
                                .byte   %00111110
                                .byte   %00011100
                                .byte   %00011100
                                .byte   %00010100
                                .byte   %00011100
                                .byte   %00010100
                                .byte   %00011100
                                .byte   %00011100
                                .byte   %00011100
                                .byte   %00001000

SMARTIEL1
                                .byte   %00000000
                                .byte   %10100000
                                .byte   %01010000
                                .byte   %10100000
                                .byte   %01010000
                                .byte   %11110000
                                .byte   %01100000
                                .byte   %00000000

SMARTIER1
                                .byte   %00000000
                                .byte   %00001010
                                .byte   %00000101
                                .byte   %00001010
                                .byte   %00000101
                                .byte   %00001111
                                .byte   %00000110
                                .byte   %00000000

SMARTIEL2
                                .byte   %00000000
                                .byte   %01010000
                                .byte   %10100000
                                .byte   %01010000
                                .byte   %10100000
                                .byte   %11110000
                                .byte   %01100000
                                .byte   %00000000

SMARTIER2
                                .byte   %00000000
                                .byte   %00000101
                                .byte   %00001010
                                .byte   %00000101
                                .byte   %00001010
                                .byte   %00001111
                                .byte   %00000110
                                .byte   %00000000

TOWERS
                                .byte   %00000000
                                .byte   %00111000
                                .byte   %00111000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %01111100
                                .byte   %00111000
                                .byte   %00111000
                                .byte   %00111000
                                .byte   %01111100
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %01111100
                                .byte   %00111000

BASE
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %01111100
                                .byte   %00111000


DOME
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %01111110
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00111100
                                .byte   %00111100
                                .byte   %01111110
                                .byte   %11111111
                                .byte   %11011011
                                .byte   %11111111
                                .byte   %01111110
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00000000

CANON
    .byte   %11111111
    .byte   %11111111
    .byte   %00111100
    .byte   %00111100
    .byte   %00010000
    .byte   %00010000
    .byte   %00001000
    .byte   %00001000

CANNONCOL
                                .byte   BROWN
                                .byte   BROWN
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED
                                .byte   RED

shiptab
    .byte 8
    .byte 8
    .byte 8
    .byte 8

hmovetab
    .byte $80,$70,$60,$50,$40,$30,$20,$10,$00
    .byte $F0,$E0,$D0,$C0,$B0,$A0,$90

digittab
    .byte #<zero,#<one,#<two,#<three,#<four
    .byte #<five,#<six,#<seven,#<eight,#<nine

disintigratetab
    .byte %01111111
    .byte %10111111
    .byte %11011111
    .byte %11101111
    .byte %11110111
    .byte %11111011
    .byte %11111101
    .byte %11111110

SHIELDCOLOR
    .byte YELLOW, YELLOW, YELLOW, RED, RED, RED

SHIELDINDEX
    .byte 6, 6, 6, 0, 0, 0

DIRTAB
    .byte %00001001
    .byte %00000001
    .byte %00000101
    .byte %00000100
    .byte %00000110
    .byte %00000010
    .byte %00001010
    .byte %00001000

BASECOL
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   GREEN
                                .byte   GREEN
                                .byte   WHITE

DOMECOL
                                .byte   BLACK
                                .byte   BLACK
                                .byte   BLACK
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   RED
                                .byte   YELLOW
                                .byte   RED
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE
                                .byte   BLUE

SMARTIECOL
                                .byte   BLACK
                                .byte   GREEN
                                .byte   BLUE
                                .byte   GREEN
                                .byte   BLUE
                                .byte   GREY
                                .byte   GREY
                                .byte   BLACK

    ORG $FFFA
    .word Start, Start, Start
